/*
 * File:        relief.vs
 * Project:     Trailer 2006
 * Author:      Johanna Schmidt & Andreas Monitzer
 * Description: A vertex shader used for relief mapping.
 *
 * (c)2006 Johanna Schmidt, Andreas Monitzer. All Rights Reserved.
 */


varying vec4 vpos;
varying vec3 view;
varying vec3 tview;
varying vec3 normal_viewspace;
varying vec3 texCoord;
varying vec3 normal;


void main(void) {

	gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	gl_TexCoord[1] = gl_TextureMatrix[1] * gl_MultiTexCoord1;
	gl_TexCoord[2] = gl_TextureMatrix[2] * gl_MultiTexCoord2;
	gl_TexCoord[3] = gl_TextureMatrix[3] * gl_MultiTexCoord3;

	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	
	vpos = gl_ModelViewMatrix * gl_Vertex;
	view = (-vpos).xyz;
	
	normal_viewspace = normalize(gl_ModelViewProjectionMatrixInverseTranspose * vec4(gl_Normal,0.0));
	
	texCoord = gl_MultiTexCoord0.xyz;
	
	normal = normalize(gl_Normal);
	float a = dot(normal, vec3(0.0,1.0,0.0));
	float b = dot(normal, vec3(1.0,0.0,0.0));
	vec3 tangent;
	if (a < b) {
		tangent = vec3(0.0, 1.0, 0.0);
	}
	else {
		tangent = vec3(1.0, 0.0, 0.0);
	}
	//tangent[0] = normal[1];
	//tangent[1] = normal[0];
	//tangent[2] = normal[2];
	
	vec3 binormal = cross(tangent, gl_Normal); // Tangent Space
	vec3 eyeVector = normalize((gl_ModelViewMatrix * gl_Vertex).xyz);
	// bring eye vector into tangent space
	tview[0] = dot(eyeVector, tangent);
	tview[1] = dot(eyeVector, binormal);
	tview[2] = dot(normal, -eyeVector);
	
}
