/*
 * File:        shadow.vs
 * Project:     Trailer 2006
 * Author:      Johanna Schmidt & Andreas Monitzer
 * Description: A vertex shader used for rendering using the shadow map (plus everything else).
 *
 * (c)2006 Johanna Schmidt, Andreas Monitzer. All Rights Reserved.
 */

varying vec4 vpos;
varying vec3 normal;
varying vec3 view;

varying vec3 normal_viewspace;


uniform mat4 shadowViewProjectionMatrix0;
uniform mat4 shadowMapMatrix0;

void main(void) {
	
	//vec4 lightpos = gl_ProjectionMatrix * gl_LightSource[0].position;

	gl_FrontColor = gl_Color;
	gl_BackColor = gl_Color;
	
	gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	gl_TexCoord[1] = gl_TextureMatrix[1] * gl_MultiTexCoord1;
	gl_TexCoord[2] = gl_TextureMatrix[2] * gl_MultiTexCoord2;
	gl_TexCoord[3] = gl_TextureMatrix[3] * gl_MultiTexCoord3;

	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	
	/* lighting stuff */
	vpos = gl_ModelViewMatrix * gl_Vertex;
	normal = gl_NormalMatrix * gl_Normal;
	view = (-vpos).xyz;

	normal_viewspace = normalize(gl_ModelViewProjectionMatrixInverseTranspose * vec4(gl_Normal,0.0));
}
