/*
 * File:        shadowtex.fs
 * Project:     Trailer 2006
 * Author:      Johanna Schmidt & Andreas Monitzer
 * Description: A minimalistic fragment shader used for creating the shadow map.
 *
 * (c)2006 Johanna Schmidt, Andreas Monitzer. All Rights Reserved.
 */

uniform sampler2D texUnit0; // diffuse texture
uniform mat4 shadowViewProjectionMatrix0;

varying vec4 pos;
varying vec3 normal_viewspace;

void main(void) {
	vec4 color = texture2D(texUnit0, gl_TexCoord[0].st);
	
	if(color.a < 0.001)
		discard;
	
	vec4 uniformPos = shadowViewProjectionMatrix0 * pos;
	
	gl_FragDepth = uniformPos.z / uniformPos.w/* + .00001 + .03 * (dot(normal_viewspace, vec3(0.0,0.0,1.0)) * .5 + .5)*/; // workaround for polygon offset problem by the paper's authors
	
	gl_FragColor = vec4(1.0,1.0,1.0,1.0);
}
