/*
 * File:        shadowtex.vs
 * Project:     Trailer 2006
 * Author:      Johanna Schmidt & Andreas Monitzer
 * Description: A minimalistic vertex shader used for creating the shadow map.
 *
 * (c)2006 Johanna Schmidt, Andreas Monitzer. All Rights Reserved.
 */

uniform mat4 shadowViewProjectionMatrix0;

varying vec4 pos;
varying vec3 normal_viewspace;

void main(void) {
	pos = gl_ModelViewMatrix * gl_Vertex;

	gl_TexCoord[0] = gl_MultiTexCoord0;
	gl_TexCoord[1] = gl_MultiTexCoord1;
	gl_TexCoord[2] = gl_MultiTexCoord2;
	gl_TexCoord[3] = gl_MultiTexCoord3;
	
	/* polygon offset problem workaround: since we can't calculate the "change in depth relative
	   to the screen area of the polygon", we'll just use the normal vector as the factor instead,
	   and hope that it doesn't cause too much troubles.
	   glPolygonOffset can't be used, since we're writing gl_FragOffset in the fragment shader.
	   Apparently, this causes glPolygonOffset to not do anything (at least on my NVidia 7800 GT).
	*/
	normal_viewspace = normalize(gl_ModelViewProjectionMatrix * vec4(gl_Normal,0.0));

	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
}
